<?xml version="1.0" encoding="UTF-8"?><!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Strict//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-strict.dtd"><html xmlns="http://www.w3.org/1999/xhtml" lang="en"><head><meta http-equiv="Content-Type" content="text/html;charset=UTF-8"/><link rel="stylesheet" href="../jacoco-resources/report.css" type="text/css"/><link rel="shortcut icon" href="../jacoco-resources/report.gif" type="image/gif"/><title>NamedForkJoinWorkerThread.java</title><link rel="stylesheet" href="../jacoco-resources/prettify.css" type="text/css"/><script type="text/javascript" src="../jacoco-resources/prettify.js"></script></head><body onload="window['PR_TAB_WIDTH']=4;prettyPrint()"><div class="breadcrumb" id="breadcrumb"><span class="info"><a href="../jacoco-sessions.html" class="el_session">Sessions</a></span><a href="../index.html" class="el_report">protean-tests</a> &gt; <a href="index.source.html" class="el_package">io.gitlab.littlesaints.protean</a> &gt; <span class="el_source">NamedForkJoinWorkerThread.java</span></div><h1>NamedForkJoinWorkerThread.java</h1><pre class="source lang-java linenums">/*
 *                     protean-core
 *              Copyright (C) 2018 Varun Anand
 *
 * This file is part of protean-core.
 *
 * protean-core is free software: you can redistribute it and/or modify
 * it under the terms of the GNU Lesser General Public License as published by
 * the Free Software Foundation, either version 3 of the License, or
 * at your option) any later version.
 *
 * protean-core is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
 * GNU Lesser General Public License for more details.
 *
 * You should have received a copy of the GNU Lesser General Public License
 * along with this program.  If not, see &lt;http://www.gnu.org/licenses/&gt;.
 */

package io.gitlab.littlesaints.protean;

import java.util.concurrent.ForkJoinPool;
import java.util.concurrent.ForkJoinWorkerThread;

/**
 * @author Varun Anand
 * @since 1.0
 */
public class NamedForkJoinWorkerThread extends ForkJoinWorkerThread {

    private final String baseName;

    private final Runnable onClose;

    public NamedForkJoinWorkerThread(String baseName, ForkJoinPool pool, Runnable onClose) {
<span class="fc" id="L37">        super(pool);</span>
<span class="fc" id="L38">        this.baseName = baseName;</span>
<span class="fc" id="L39">        this.onClose = onClose;</span>
<span class="fc" id="L40">    }</span>

    public NamedForkJoinWorkerThread(String baseName, ForkJoinPool pool) {
<span class="nc" id="L43">        this(baseName, pool, () -&gt; {});</span>
<span class="nc" id="L44">    }</span>

    @Override
    protected void onStart() {
<span class="fc" id="L48">        super.onStart();</span>
<span class="fc" id="L49">        Thread.currentThread().setName(baseName + &quot;::worker-&quot; + getPoolIndex());</span>
<span class="fc" id="L50">    }</span>

    @Override
    protected void onTermination(Throwable exception) {
<span class="fc" id="L54">        super.onTermination(exception);</span>
<span class="fc" id="L55">        this.onClose.run();</span>
<span class="fc" id="L56">    }</span>
}
</pre><div class="footer"><span class="right">Created with <a href="http://www.jacoco.org/jacoco">JaCoCo</a> 0.8.4.201905082037</span></div></body></html>